#ifndef __ndk_tss_h__
#define __ndk_tss_h__

#include "ndk.h"
#include "gdt.h"
#include "array.h"
#include "descgate.h"

/* TSS definition */
typedef struct {        /* TSS for 386+ */
  long  link,
        esp0,
        ss0,
        esp1,
        ss1,
        esp2,
        ss2,
        cr3,
        eip,
        eflags,
        eax,
        ecx,
        edx,
        ebx,
        esp,
        ebp,
        esi,
        edi,
        es,
        cs,
        ss,
        ds,
        fs,
        gs,
        ldtr;
  short trace,
        io_map_addr;
} TSS;

typedef struct {        /* TSS for 386+ */
  long  link,
        esp0,
        ss0,
        esp1,
        ss1,
        esp2,
        ss2,
        cr3,
        eip,
        eflags,
        eax,
        ecx,
        edx,
        ebx,
        esp,
        ebp,
        esi,
        edi,
        es,
        cs,
        ss,
        ds,
        fs,
        gs,
        ldtr;
  short trace,
        io_map_addr;
  char  io_map[8192];
} TSSWithIOMap;

typedef struct {
  long  tss;
  short selector;
  long  next;
} Task;

extern Task *currentTask;
extern Task *firstTask;

#endif
