#include "timer.h"

void timerInit(void) {
  createGate(&IDT, 0x20, (long)int20h_wrapper, SEL_P0_CODE, D_INT);
  picEnableIRQ(0);
  asm("sti");
}

void timerHandler() {
  char *scr = (char *)0x000b8000;

  //ticks++;
  //scr = MK_FP (0x20, 80*4+8*2);
  scr[0]++;

  outportb (M_PIC, EOI);
  timerScheduler();
}

void timerScheduler(void) {
  /* if there's 0 or 1 task, no need to cycle */
  if(firstTask == NULL ||
     firstTask->next == NULL) return;

  /* standard round robin scheduler */
  currentTask = (Task *)currentTask->next;
  if(currentTask == NULL)
    currentTask = (Task *)firstTask;

  //printf("jmp to %x\n", currentTask->selector);
  jumpToTSS(currentTask->selector);
}